# agents window, displays agent signal strength in histogram format
# user my also send agent hints to mnd by clicking on desired agent with
# the right mouse button

	proc agents {} {
		toplevel .agents
		wm title .agents "agent signal strength"
		global agent_colors agent sig_str DO_AGENTS
		bind .agents <1> {destroy .agents; set DO_AGENTS NO}
		#-------setup window 
		frame .agents.info -height 60m
		canvas .agents.bar -width 5c -height 60m
		pack .agents.info .agents.bar -side left
		foreach color $agent_colors {
			frame .agents.$color
			frame .agents.${color}box -height .5c -width .5c -borderwidth 1
			label .agents.${color}lab -textvariable agent($color) -font -*-*-*-R-*--*-120-*-*-m-*-*-* 
			pack .agents.$color -padx 1 -side top -in .agents.info
			pack .agents.${color}box .agents.${color}lab -side left -in .agents.$color
			#puts "setting agent color $color"
		}
		#----- establish agent label bindings
		#puts "doing agent bindings"
		bind .agents.greenlab <3> {hint $agent_coa(green)}
		bind .agents.bluelab <3> {hint $agent_coa(blue)}
		bind .agents.redlab <3> {hint $agent_coa(red)}
		bind .agents.yellowlab <3> {hint $agent_coa(yellow)}
		bind .agents.orangelab <3> {hint $agent_coa(orange)}
		bind .agents.purplelab <3> {hint $agent_coa(purple)}
		bind .agents.brownlab <3> {hint $agent_coa(brown)}
		bind .agents.pinklab <3> {hint $agent_coa(pink)}
		bind .agents.blacklab <3> {hint $agent_coa(black)}

		#---- set up signal strength bar graph
        	.agents.bar create line .8c 55.1m .8c 5m
	        for {set draw 5} {$draw<=55} {incr draw 5 } {
			if {$draw == 5} {
				.agents.bar create text .6m ${draw}m -text [expr (55-$draw)*2] -anchor w -width 2c
			} else {
				
                	.agents.bar create text .2c ${draw}m -text [expr (55-$draw)*2] -anchor w -width 2c 
			}
       		        .agents.bar create line .7c ${draw}m .8c ${draw}m
        	}
		set DO_AGENTS YES
		after 1000 update_agents
        }
	
	proc update_agents {} {
		global agent_colors agent sig_str agent_coa ag_bar num_agents AGENTS DO_AGENTS curr_agent MAX_AGENTS
		if {$DO_AGENTS == "NO"} {
			return
		}
		set agent_values [split [get_mnd_info $AGENTS] |]
		for {set i 0} {$i < $num_agents} {incr i} {
			.agents.bar delete $ag_bar([lindex $agent_colors $i])
		}
		set num_agents [lindex $agent_values 0]
		if { $num_agents > $MAX_AGENTS } {
			set num_agents $MAX_AGENTS
		}
		#puts "num agents = $num_agents"
		#puts "curr agent = $curr_agent"
		if {$curr_agent != "NONE"} {
			.agents.${curr_agent}lab configure -bg #d9d9d9 -fg black
		}
		set curr_agent [lindex $agent_values [expr (3*$num_agents)+1]]
		if {$curr_agent != "NONE"} {
			set curr_agent [lindex $agent_colors $curr_agent]
			.agents.${curr_agent}lab configure -bg black -fg #d9d9d9 -font -*-*-*-R-*--*-120-*-*-m-*-*-*
		}
		#puts "current agent = $curr_agent"
		for {set i 0} {$i < $num_agents} {incr i} {
			set color [lindex $agent_colors $i]
			#puts "color = $color"
			set agent($color) [lindex $agent_values [expr (3*$i)+1]] 
			set agent($color) [format "%-11s" $agent($color)]
			#puts "agent($color) = $agent($color)"
			set agent_coa($color) [lindex $agent_values [expr (3*$i)+2]]
			#puts "agent coa = $agent_coa($color)"
			set sig_str($color) [lindex $agent_values [expr (3*$i)+3]]
			#set sig_str($color) 5
			#puts "sig_str($color) = $sig_str($color)"
			set ag_bar($color) [.agents.bar create rectangle [expr ($i*.5)+1]c [expr 55-($sig_str($color)/2)]m [expr ($i*.5)+1.5]c 55m -fill $color]
			.agents.${color}box configure -background $color -relief sunken
		}
		for {} {$i<4} {incr i} {
			set color [lindex $agent_colors $i]
			set agent($color) "          "
			.agents.${color}box configure -background #d9d9d9 -relief flat
		}
		after 1000 update_agents
	}
			
