# icmp beacon statistics 

proc beac_stats {} {
	toplevel .bstats
	wm title .bstats "icmp beacon statistics"

	bind .bstats <Button> {destroy .bstats; set DO_BSTATS NO}

	global ha_beacons_sent fa_beacons_sent mn_beacons_sent
	global all_beacons_recv all_netauth_recv valid_beacons_recv faisha_recv tooshort
	global msetooshort invalidicmpmse bothhafa auth_nomac
	global ha_netauthbad fa_netauthbad mn_netauthbad
	global ha_adhoc_authbad fa_adhoc_authbad mn_adhoc_authbad
	global ha_maybe_arp_lacks_auth fa_maybe_arp_lacks_auth mn_maybe_arp_lacks_auth
	global arp_on_mn_beacons_ignored valid_arp_beacons valid_auth_beacons BEAC_STATS DO_BSTATS

	set DO_BSTATS YES

	frame .bstats.all -relief sunken -borderwidth 4 -width 10c 

	frame .bstats.ha_beacons_sent 
		label .bstats.ha_beacons_sent.txt -text "HA beacons_sent: "
		label .bstats.ha_beacons_sent.val -textvariable ha_beacons_sent
		pack .bstats.ha_beacons_sent.txt .bstats.ha_beacons_sent.val -side left
	frame .bstats.fa_beacons_sent 
		label .bstats.fa_beacons_sent.txt -text "FA beacons_sent: "
		label .bstats.fa_beacons_sent.val -textvariable fa_beacons_sent
		pack .bstats.fa_beacons_sent.txt .bstats.fa_beacons_sent.val -side left
	frame .bstats.mn_beacons_sent 
		label .bstats.mn_beacons_sent.txt -text "MN beacons_sent: "
		label .bstats.mn_beacons_sent.val -textvariable mn_beacons_sent
		pack .bstats.mn_beacons_sent.txt .bstats.mn_beacons_sent.val -side left
	frame .bstats.all_beacons_recv
		label .bstats.all_beacons_recv.txt -text "All beacons recvd: "
		label .bstats.all_beacons_recv.val -textvariable all_beacons_recv
		pack .bstats.all_beacons_recv.txt .bstats.all_beacons_recv.val -side left
	frame .bstats.all_netauth_recv
		label .bstats.all_netauth_recv.txt -text "All netauth recvd: "
		label .bstats.all_netauth_recv.val -textvariable all_netauth_recv
		pack .bstats.all_netauth_recv.txt .bstats.all_netauth_recv.val -side left
	frame .bstats.valid_beacons_recv
		label .bstats.valid_beacons_recv.txt -text "Valid beacons recvd: "
		label .bstats.valid_beacons_recv.val -textvariable valid_beacons_recv
		pack .bstats.valid_beacons_recv.txt .bstats.valid_beacons_recv.val -side left
#	frame .bstats.faisha_recv
#		label .bstats.faisha_recv.txt -text "FA beacons as HA: "
#		label .bstats.faisha_recv.val -textvariable faisha_recv
#		pack .bstats.faisha_recv.txt .bstats.faisha_recv.val -side left
#	frame .bstats.tooshort
#		label .bstats.tooshort.txt -text "message too short: "
#		label .bstats.tooshort.val -textvariable tooshort
#		pack .bstats.tooshort.txt .bstats.tooshort.val -side left
#	frame .bstats.msetooshort
#		label .bstats.msetooshort.txt -text "mip part too short: "
#		label .bstats.msetooshort.val -textvariable msetooshort
#		pack .bstats.msetooshort.txt .bstats.msetooshort.val
	frame .bstats.invalidicmpmse
		label .bstats.invalidicmpmse.txt -text "mse invalid: "
		label .bstats.invalidicmpmse.val -textvariable invalidicmpmse
		pack .bstats.invalidicmpmse.txt .bstats.invalidicmpmse.val -side left
#	frame .bstats.bothhafa
#		label .bstats.bothhafa.txt -text "both ha & fa bits set: "
#		label .bstats.bothhafa.val -textvariable bothhafa
#		pack .bstats.bothhafa.txt .bstats.bothhafa.val
	frame .bstats.auth_nomac
		label .bstats.auth_nomac.txt -text "auth but lacks mac: "
		label .bstats.auth_nomac.val -textvariable auth_nomac
		pack .bstats.auth_nomac.txt .bstats.auth_nomac.val -side left
	frame .bstats.ha_netauthbad
		label .bstats.ha_netauthbad.txt -text "net auth from HA failed: "
		label .bstats.ha_netauthbad.val -textvariable ha_netauthbad
		pack .bstats.ha_netauthbad.txt .bstats.ha_netauthbad.val -side left
	frame .bstats.fa_netauthbad
		label .bstats.fa_netauthbad.txt -text "net auth from FA failed: "
		label .bstats.fa_netauthbad.val -textvariable fa_netauthbad
		pack .bstats.fa_netauthbad.txt .bstats.fa_netauthbad.val -side left
	frame .bstats.mn_netauthbad
		label .bstats.mn_netauthbad.txt -text "net auth from MN failed: "
		label .bstats.mn_netauthbad.val -textvariable mn_netauthbad
		pack .bstats.mn_netauthbad.txt .bstats.mn_netauthbad.val -side left
#	frame .bstats.ha_adhoc_authbad
#		label .bstats.ha_adhoc_authbad.txt -text "adhoc auth from HA failed: "
#		label .bstats.ha_adhoc_authbad.val -textvariable ha_adhoc_authbad
#		pack .bstats.ha_adhoc_authbad.txt .bstats.ha_adhoc_authbad.val -side left
#	frame .bstats.fa_adhoc_authbad
#		label .bstats.fa_adhoc_authbad.txt -text "adhoc auth from FA failed: "
#		label .bstats.fa_adhoc_authbad.val -textvariable fa_adhoc_authbad
#		pack .bstats.fa_adhoc_authbad.txt .bstats.fa_adhoc_authbad.val -side left
#	frame .bstats.mn_adhoc_authbad
#		label .bstats.mn_adhoc_authbad.txt -text "adhoc auth from MN failed: "
#		label .bstats.mn_adhoc_authbad.val -textvariable mn_adhoc_authbad
#		pack .bstats.mn_adhoc_authbad.txt .bstats.mn_adhoc_authbad.val -side left
	frame .bstats.ha_maybe_arp_lacks_auth
		label .bstats.ha_maybe_arp_lacks_auth.txt -text "beacon from HA has no auth: "
		label .bstats.ha_maybe_arp_lacks_auth.val -textvariable ha_maybe_arp_lacks_auth
		pack .bstats.ha_maybe_arp_lacks_auth.txt .bstats.ha_maybe_arp_lacks_auth.val -side left
	frame .bstats.fa_maybe_arp_lacks_auth
		label .bstats.fa_maybe_arp_lacks_auth.txt -text "beacon from FA has no auth: "
		label .bstats.fa_maybe_arp_lacks_auth.val -textvariable fa_maybe_arp_lacks_auth
		pack .bstats.fa_maybe_arp_lacks_auth.txt .bstats.fa_maybe_arp_lacks_auth.val -side left
	frame .bstats.mn_maybe_arp_lacks_auth
		label .bstats.mn_maybe_arp_lacks_auth.txt -text "beacon from MN has no auth: "
		label .bstats.mn_maybe_arp_lacks_auth.val -textvariable mn_maybe_arp_lacks_auth
		pack .bstats.mn_maybe_arp_lacks_auth.txt .bstats.mn_maybe_arp_lacks_auth.val -side left
	frame .bstats.arp_on_mn_beacons_ignored
		label .bstats.arp_on_mn_beacons_ignored.txt -text "arp on, mn beacons discarded: "
		label .bstats.arp_on_mn_beacons_ignored.val -textvariable arp_on_mn_beacons_ignored
		pack .bstats.arp_on_mn_beacons_ignored.txt .bstats.arp_on_mn_beacons_ignored.val -side left
	frame .bstats.valid_arp_beacons
		label .bstats.valid_arp_beacons.txt -text "valid arp beacons: "
		label .bstats.valid_arp_beacons.val -textvariable valid_arp_beacons
		pack .bstats.valid_arp_beacons.txt .bstats.valid_arp_beacons.val -side left
	frame .bstats.valid_auth_beacons
		label .bstats.valid_auth_beacons.txt -text "valid auth beacons: "
		label .bstats.valid_auth_beacons.val -textvariable valid_auth_beacons
		pack .bstats.valid_auth_beacons.txt .bstats.valid_auth_beacons.val -side left

	pack .bstats.ha_beacons_sent .bstats.fa_beacons_sent .bstats.mn_beacons_sent -in .bstats.all -side top
	pack .bstats.all_beacons_recv .bstats.all_netauth_recv .bstats.valid_beacons_recv -in .bstats.all -side top
	pack .bstats.auth_nomac -in .bstats.all -side top
	pack .bstats.ha_netauthbad .bstats.fa_netauthbad .bstats.mn_netauthbad -in .bstats.all -side top
	#pack .bstats.ha_adhoc_authbad .bstats.fa_adhoc_authbad .bstats.mn_adhoc_authbad -in .bstats.all -side top
	pack .bstats.ha_maybe_arp_lacks_auth .bstats.fa_maybe_arp_lacks_auth .bstats.mn_maybe_arp_lacks_auth -in .bstats.all -side top
	pack .bstats.arp_on_mn_beacons_ignored .bstats.valid_arp_beacons .bstats.valid_auth_beacons -in .bstats.all -side top

	pack .bstats.all
	after 1000 update_beaconstats
}


proc update_beaconstats {} {
	global ha_beacons_sent fa_beacons_sent mn_beacons_sent
	global all_beacons_recv all_netauth_recv valid_beacons_recv faisha_recv tooshort
	global msetooshort invalidicmpmse bothhafa auth_nomac
	global ha_netauthbad fa_netauthbad mn_netauthbad
	global ha_adhoc_authbad fa_adhoc_authbad mn_adhoc_authbad
	global ha_maybe_arp_lacks_auth fa_maybe_arp_lacks_auth mn_maybe_arp_lacks_auth
	global arp_on_mn_beacons_ignored valid_arp_beacons valid_auth_beacons DO_BSTATS BEAC_STATS

	if {$DO_BSTATS == "NO"} {
		return
	}

	set bstat_values [eval list [get_mnd_info $BEAC_STATS]]
	set ha_beacons_sent [lindex $bstat_values 0]
	set fa_beacons_sent [lindex $bstat_values 1]
	set mn_beacons_sent [lindex $bstat_values 2]
	set all_beacons_recv [lindex $bstat_values 3]
	set all_netauth_recv [lindex $bstat_values 4]
	set valid_beacons_recv [lindex $bstat_values 5]
	set faisha_recv [lindex $bstat_values 6]
	set tooshort [lindex $bstat_values 7]
	set msetooshort [lindex $bstat_values 8]
	set invalidicmpmse [lindex $bstat_values 9]
	set bothhafa [lindex $bstat_values 10]
	set auth_nomac [lindex $bstat_values 11]
	set ha_netauthbad [lindex $bstat_values 12]
	set fa_netauthbad [lindex $bstat_values 13]
	set mn_netauthbad [lindex $bstat_values 14]
	set ha_adhoc_authbad [lindex $bstat_values 15]
	set fa_adhoc_authbad [lindex $bstat_values 16]
	set mn_adhoc_authbad [lindex $bstat_values 17]
	set ha_maybe_arp_lacks_auth [lindex $bstat_values 18]
	set fa_maybe_arp_lacks_auth [lindex $bstat_values 19]
	set mn_maybe_arp_lacks_auth [lindex $bstat_values 20]
	set arp_on_mn_beacons_ignored [lindex $bstat_values 21]
	set valid_arp_beacons [lindex $bstat_values 22]
	set valid_auth_beacons [lindex $bstat_values 23]

	after 1000 update_beaconstats
}

