# mns window, displays mn signal strength in histogram format

	proc mns {} {
		toplevel .mns
		wm title .mns "mn signal strength"
		global mn_colors mn sig_str DO_MNS
		bind .mns <1> {destroy .mns; set DO_MNS NO}
		#-------setup window 
		frame .mns.info -height 60m
		canvas .mns.bar -width 5c -height 60m
		pack .mns.info .mns.bar -side left
		foreach color $mn_colors {
			frame .mns.$color
			frame .mns.${color}box -height .5c -width .5c -borderwidth 1
			label .mns.${color}lab -textvariable mn($color) -font -*-*-*-R-*--*-120-*-*-m-*-*-* 
			pack .mns.$color -padx 1 -side top -in .mns.info
			pack .mns.${color}box .mns.${color}lab -side left -in .mns.$color
		}

		#---- set up signal strength bar graph
        	.mns.bar create line .8c 55.1m .8c 5m
	        for {set draw 5} {$draw<=55} {incr draw 5 } {
			if {$draw == 5} {
				.mns.bar create text .6m ${draw}m -text [expr (55-$draw)*2] -anchor w -width 2c
			} else {
				
                	.mns.bar create text .2c ${draw}m -text [expr (55-$draw)*2] -anchor w -width 2c 
			}
       		        .mns.bar create line .7c ${draw}m .8c ${draw}m
        	}
		set DO_MNS YES
		after 1000 update_mns
        }
	
	proc update_mns {} {
		global mn_colors mn sig_str mn_coa ag_bar num_mns MNS DO_MNS MAX_MNS 
		if {$DO_MNS == "NO"} {
			return
		}
		set mn_values [split [get_mnd_info $MNS] |]
		for {set i 0} {$i < $num_mns} {incr i} {
			.mns.bar delete $ag_bar([lindex $mn_colors $i])
		}
		set num_mns [lindex $mn_values 0]
		if { $num_mns > $MAX_MNS } {
			set num_mns $MAX_MNS
		}
		for {set i 0} {$i < $num_mns} {incr i} {
			set color [lindex $mn_colors $i]
			#puts "color = $color"
			set mn($color) [lindex $mn_values [expr (3*$i)+1]] 
			set mn($color) [format "%-11s" $mn($color)]
			#puts "mn($color) = $mn($color)"
			set mn_coa($color) [lindex $mn_values [expr (3*$i)+2]]
			set sig_str($color) [lindex $mn_values [expr (3*$i)+3]]
			#set sig_str($color) 5
			#puts "sig_str($color) = $sig_str($color)"
			set ag_bar($color) [.mns.bar create rectangle [expr ($i*.5 )+1]c [expr 55-($sig_str($color)/2)]m [expr ($i*.5)+1.5]c 55m -fill $color]
			.mns.${color}box configure -background $color -relief sunken
		}
		for {} {$i<4} {incr i} {
			set color [lindex $mn_colors $i]
			set mn($color) "          "
			.mns.${color}box configure -background #d9d9d9 -relief flat
		}
		after 1000 update_mns
	}
			
