# netauth main window

	proc netauth {} {
       		toplevel .neta
	       	wm title .neta "network authentication"
		global arp net_auth ad_hoc DO_DUMBLIGHTS 
		global dl_val_beacs dl_auth_badkey dl_netauth_nokey dl_arp_key

		#-- read current configuration from file-----
		set policy_vals [split [mndconfigure read] |]
		set net_auth [lindex $policy_vals 0]
		set ad_hoc [lindex $policy_vals 1]
		set arp [lindex $policy_vals 2]

		set DO_DUMBLIGHTS YES

		frame .neta.border1 -height 4 -relief ridge -borderwidth 4
		frame .neta.border2 -height 4 -relief ridge -borderwidth 4
		frame .neta.border3 -height 4 -relief ridge -borderwidth 4
		frame .neta.menu
		menubutton .neta.menu.keyman -text "keys" -menu .neta.menu.keyman.options -underline 0
		menu .neta.menu.keyman.options
			.neta.menu.keyman.options add command -label "mnha key" -command {key mnha}
			.neta.menu.keyman.options add command -label "famn key" -command {key famn}
			.neta.menu.keyman.options add command -label "netauth key" -command {key netauth}
			.neta.menu.keyman.options add command -label "ad hoc key" -command {key adhoc}
		menubutton .neta.menu.help -text "help" -menu .neta.menu.help.options -underline 0
		menu .neta.menu.help.options
			.neta.menu.help.options add command -label "indicator lights" -command {help lights.hlp}
			.neta.menu.help.options add command -label "key management" -command {help keymanage.hlp}
			.neta.menu.help.options add command -label "key policy" -command {help policy.hlp}
			.neta.menu.help.options add command -label "arp mode" -command {help arpmode.hlp}
			.neta.menu.help.options add command -label "config file" -command {help configfile.hlp}
		menubutton .neta.menu.ops -text "ops" -menu .neta.menu.ops.options -underline 0
		menu .neta.menu.ops.options
			.neta.menu.ops.options add command -label "beacon stats" -command beac_stats
		pack .neta.menu.ops .neta.menu.keyman .neta.menu.help -side left
		pack .neta.menu .neta.border2 -side top -fill x


        	set fields [list types accept reject]
	        set domains [list net_auth ad_hoc]

       		foreach field $fields {
               		 frame .neta.$field -width 2c -height 5c
        	}

		# save buttons
	        frame .neta.sav_close -height 1.5c -borderwidth 4
		pack .neta.sav_close -side bottom  
		pack .neta.border3 -side bottom -fill x
		button .neta.save -text "WRITE CONFIG FILE" -command {mndconfigure write}
		button .neta.close -text "EXIT" -command {set DO_DUMBLIGHTS NO; destroy .neta; destroy .keys}
		pack .neta.save .neta.close -side left -pady 1m -padx 1c -in .neta.sav_close

		# arp buttons
		frame .neta.arp -height 1.5c -borderwidth 4
		radiobutton .neta.arp_on -text "arp on" -variable arp -value on
		radiobutton .neta.arp_off -text "arp off" -variable arp -value off
		pack .neta.arp_on .neta.arp_off -side left -pady 1m -padx 1c -in .neta.arp


		# dumb lights ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		# valid beacons
		frame .neta.valbeaclight -borderwidth 4
		label .neta.valbeaclight.light -bitmap @/usr/X11R6/include/X11/bitmaps/dot -fg #d9d9d9 -bg grey
		label .neta.valbeaclight.txt -text "valid beacons"
		pack .neta.valbeaclight.light .neta.valbeaclight.txt -side left

		# auth - bad key
		frame .neta.badkeylight -borderwidth 4
		label .neta.badkeylight.light -bitmap @/usr/X11R6/include/X11/bitmaps/dot -fg #d9d9d9 -bg grey
		label .neta.badkeylight.txt -text "auth - bad key"
		pack .neta.badkeylight.light .neta.badkeylight.txt -side left

		# netauth - no key
		frame .neta.nokeylight -borderwidth 4
		label .neta.nokeylight.light -bitmap @/usr/X11R6/include/X11/bitmaps/dot -fg #d9d9d9 -bg grey
		label .neta.nokeylight.txt -text "netauth - no key (receiving arp?)"
		pack .neta.nokeylight.light .neta.nokeylight.txt -side left
		
		# arp - key
		frame .neta.arpkeylight -borderwidth 4
		label .neta.arpkeylight.light -bitmap @/usr/X11R6/include/X11/bitmaps/dot -fg #d9d9d9 -bg grey
		label .neta.arpkeylight.txt -text "arp - key (receiving adhoc or netauth?)"
		pack .neta.arpkeylight.light .neta.arpkeylight.txt -side left

		pack .neta.arpkeylight -side bottom -fill x
		pack .neta.nokeylight -side bottom -fill x
		pack .neta.badkeylight -side bottom -fill x
		pack .neta.valbeaclight -side bottom -fill x
		pack .neta.border1 .neta.arp -side bottom -fill x

		# key buttons
		pack .neta.types .neta.accept .neta.reject -side left 

		set fields [lreplace $fields 0 0] 
		 # types--------
		label .neta.nada -text " "
		label .neta.net_auth -text "NET AUTH(all)"
		label .neta.ad_hoc -text "AD HOC(all)"
		pack .neta.nada .neta.net_auth .neta.ad_hoc -side top -pady 1m -in .neta.types
		# buttons ------------
		foreach field $fields {
			label .neta.${field}lab -text $field
			pack .neta.${field}lab -in .neta.$field -padx 2m
			foreach domain $domains {
                        	radiobutton .neta.${domain}_${field} -variable $domain -value $field
	                        pack .neta.${domain}_${field} -side top -in .neta.$field
				
			}
        	}

		# arp management
		bind .neta.arp_on <ButtonPress> {disable; link_mode $AUTH_TO_ARP}
		bind .neta.arp_off <ButtonPress> {enable; link_mode $ARP_TO_AUTH}
		if {$arp == "on"} {
			disable
		}
		bind .neta.net_auth_accept <ButtonPress> {auth_policy $ACCEPT_NETAUTH}
		bind .neta.net_auth_reject <ButtonPress> {auth_policy $REJECT_NETAUTH}
		bind .neta.ad_hoc_accept <ButtonPress> {auth_policy $ACCEPT_ADHOC}
		bind .neta.ad_hoc_reject <ButtonPress> {auth_policy $REJECT_ADHOC}

		after 1000 update_dumblights
	}



	# white out options if arp is turned on
	proc disable {} {
		.neta.net_auth configure -fg grey
		.neta.ad_hoc configure -fg grey
		.neta.acceptlab configure -fg grey
		.neta.rejectlab configure -fg grey
	}

	# un-white out options if arp is turned off
	proc enable {} {
		.neta.net_auth configure -fg black
		.neta.ad_hoc configure -fg black
		.neta.acceptlab configure -fg black
		.neta.rejectlab configure -fg black
	}


	set key_type 0

	proc key {k_type} {
		toplevel .keys
		wm title .keys "key management"
		global key_type 
		set key_type $k_type
		#bind .keys <Button> {destroy .keys}
		set keyvals [split [mndconfigure getkey $k_type] |]
		set k_trans [lindex $keyvals 0]
		set hex_key [lindex $keyvals 1]

		label .keys.type -text "Key type: $k_type"
		label .keys.trans -text "Transform: $k_trans"
		label .keys.key -text "Current key: $hex_key"

		frame .keys.buttons
		button .keys.new -text "enter new key" -command {keygen enter}
		button .keys.gen -text "generate key" -command {keygen gen}
		button .keys.pass -text "passphrase gen." -command {keygen pass}
		button .keys.quit -text "quit" -command {destroy .keys; destroy .input}
		pack .keys.new .keys.gen .keys.pass .keys.quit -in .keys.buttons -side left
		pack .keys.type .keys.trans .keys.key .keys.buttons -side top
	}

	proc keygen {gen_type} {
		global key_type 
		switch $gen_type {
			enter {
				toplevel .input
				wm title .input "key entry"
				bind .input <Return> {
					if {[string compare $enterkey "none"] == 0} {
						mndconfigure $key_type 00000000000000000000000000000000
						set hex_key 00000000000000000000000000000000 
						.keys.key configure -text "Current key: $hex_key" 
						update 
						destroy .input
						unset enterkey
						return
					}
					if {[string length $enterkey] != 32} {
						set enterkey "key must be 32 characters"
						update
						after 1000
						set enterkey ""
						update
					} else {
						mndconfigure $key_type $enterkey
						.keys.key configure -text "Current key: $enterkey"
						destroy .input
						unset enterkey
						return
					}
				}
				frame .input.entrybox 
				label .input.label -text "enter key: "
				entry .input.entry -width 32 -relief sunken -bd 2 -textvariable enterkey
				pack .input.label .input.entry -in .input.entrybox -side left
				pack .input.entrybox
				} 
			pass {
				toplevel .input
				wm title .input "passphrase entry"
				bind .input <Return> {
					set temp [exec /sbin/md5 -s$passkey]
					set key [lindex [split $temp =] 1]
					mndconfigure $key_type [string trim $key]
					.keys.key configure -text "Current key: [string trim $key]"
					destroy .input
					unset passkey
					}
				frame .input.entrybox
				label .input.label -text "enter pass phrase: "
				entry .input.entry -width 50 -relief sunken -bd 2 -textvariable passkey
				pack .input.label .input.entry -in .input.entrybox -side left
				pack .input.entrybox
				} 
			gen {
				set hex_key [xkeygen]
				mndconfigure $key_type $hex_key
				
				.keys.key configure -text "Current key: $hex_key"
				}
		}
	}

	proc update_dumblights {} {
		global DO_DUMBLIGHTS dl_val_beacs dl_auth_badkey dl_netauth_nokey dl_arp_key arp BEAC_STATS
		if {$DO_DUMBLIGHTS == "NO"} {
			return
		}

		# valid-beacons light
		set bstat_values [eval list [get_mnd_info $BEAC_STATS]]
		set val_beacs [lindex $bstat_values 5]
		if {$val_beacs != $dl_val_beacs} {
			.neta.valbeaclight.light configure -fg green
			set dl_val_beacs $val_beacs
		}

		# auth-badkey light
		set auth_badkey [expr [lindex $bstat_values 12] + [lindex $bstat_values 13] + [lindex $bstat_values 14]]
		if {$auth_badkey != $dl_auth_badkey} {
			.neta.badkeylight.light configure -fg red
			set dl_auth_badkey $auth_badkey
		}

		# netauth-nokey light
		set netauth_nokey [expr [lindex $bstat_values 18] + [lindex $bstat_values 19] + [lindex $bstat_values 20]]
		if {$netauth_nokey != $dl_netauth_nokey} {
			.neta.nokeylight.light configure -fg red
			set dl_netauth_nokey $netauth_nokey
		}

		# arp-key light 
		set arp_key [expr [lindex $bstat_values 4] + [lindex $bstat_values 21]]
		if {$arp_key != $dl_arp_key} {
			set dl_arp_key $arp_key
			if {$arp == "on"} {
				.neta.arpkeylight.light configure -fg red
			}
		}
		update 
		after 200
		.neta.valbeaclight.light configure -fg #d9d9d9
		.neta.badkeylight.light configure -fg #d9d9d9
		.neta.nokeylight.light configure -fg #d9d9d9
		.neta.arpkeylight.light configure -fg #d9d9d9
		after 1000 update_dumblights
	}


