	proc statistics {} {
		toplevel .stats
		wm title .stats "mnd statistics"

		bind .stats <Button> {destroy .stats; set DO_STATS NO}

		global registrations replies beacons udp_err_idm udp_err_iha
		global udp_err_ifa udp_err_hmtu heartbeat icmp_err_bts
		global icmp_err_mts icmp_err_ut icmp_err_bip icmp_err_iia
		global udp_err_mgr udp_err_rts udp_err_uxt DO_STATS
		set DO_STATS YES

		frame .stats.all -relief sunken -borderwidth 4 -width 10c -height 10c
		frame .stats.border -height 4 -relief ridge -borderwidth 4
		frame .stats.reg
			label .stats.regtxt -text "UDP registrations sent: "
			label .stats.regval -textvariable registrations
			pack .stats.regtxt .stats.regval -in .stats.reg -side left
		frame .stats.replies
			label .stats.repliestxt -text "UDP replies received: "
			label .stats.repliesval -textvariable replies
			pack .stats.repliestxt .stats.repliesval -in .stats.replies -side left
#		frame .stats.beacons
#			label .stats.beaconstxt -text "ICMP beacons received: "
#			label .stats.beaconsval -textvariable beacons
#			pack .stats.beaconstxt .stats.beaconsval -in .stats.beacons -side left
		frame .stats.udp_err_idm
			label .stats.udp_err_idmtxt -text "UDP error: ident didn't match: "
			label .stats.udp_err_idmval -textvariable udp_err_idm
			pack .stats.udp_err_idmtxt .stats.udp_err_idmval -in .stats.udp_err_idm -side left
		frame .stats.udp_err_iha
			label .stats.udp_err_ihatxt -text "UDP error: invalid ha authentication: "
			label .stats.udp_err_ihaval -textvariable udp_err_iha
			pack .stats.udp_err_ihatxt .stats.udp_err_ihaval -in .stats.udp_err_iha -side left
		frame .stats.udp_err_ifa
			label .stats.udp_err_ifatxt -text "UDP error: invalid fa authentication: "
			label .stats.udp_err_ifaval -textvariable udp_err_ifa
			pack .stats.udp_err_ifatxt .stats.udp_err_ifaval -in .stats.udp_err_ifa -side left
		frame .stats.udp_err_hmtu
			label .stats.udp_err_hmtutxt -text "UDP error: ha made time update: "
			label .stats.udp_err_hmtuval -textvariable udp_err_hmtu
			pack .stats.udp_err_hmtutxt .stats.udp_err_hmtuval -in .stats.udp_err_hmtu -side left
		frame .stats.heartbeat
			label .stats.heartbeattxt -text "heartbeat ticks: "
			label .stats.heartbeatval -textvariable heartbeat
			pack .stats.heartbeattxt .stats.heartbeatval -in .stats.heartbeat -side left
#		frame .stats.icmp_err_bts
#			label .stats.icmp_err_btstxt -text "ICMP error: beacon too short: "
#			label .stats.icmp_err_btsval -textvariable icmp_err_bts
#			pack .stats.icmp_err_btstxt .stats.icmp_err_btsval -in .stats.icmp_err_bts -side left
#		frame .stats.icmp_err_mts
#			label .stats.icmp_err_mtstxt -text "ICMP error: mse too short: "
#			label .stats.icmp_err_mtsval -textvariable icmp_err_mts
#			pack .stats.icmp_err_mtstxt .stats.icmp_err_mtsval -in .stats.icmp_err_mts -side left
#		frame .stats.icmp_err_ut
#			label .stats.icmp_err_uttxt -text "ICMP error: unknown type: "
#			label .stats.icmp_err_utval -textvariable icmp_err_ut
#			pack .stats.icmp_err_uttxt .stats.icmp_err_utval -in .stats.icmp_err_ut -side left
#		frame .stats.icmp_err_bip
#			label .stats.icmp_err_biptxt -text "ICMP error: both ha fa in one pkt: "
#			label .stats.icmp_err_bipval -textvariable icmp_err_bip
#			pack .stats.icmp_err_biptxt .stats.icmp_err_bipval -in .stats.icmp_err_bip -side left
#		frame .stats.icmp_err_iia
#			label .stats.icmp_err_iiatxt -text "ICMP error: invalid icmp authentication: "
#			label .stats.icmp_err_iiaval -textvariable icmp_err_iia
#			pack .stats.icmp_err_iiatxt .stats.icmp_err_iiaval -in .stats.icmp_err_iia -side left
		frame .stats.udp_err_mgr
			label .stats.udp_err_mgrtxt -text "UDP error: mn got registration? "
			label .stats.udp_err_mgrval -textvariable udp_err_mgr
			pack .stats.udp_err_mgrtxt .stats.udp_err_mgrval -in .stats.udp_err_mgr -side left
		frame .stats.udp_err_rts
			label .stats.udp_err_rtstxt -text "UDP error: reply too short: "
			label .stats.udp_err_rtsval -textvariable udp_err_rts
			pack .stats.udp_err_rtstxt .stats.udp_err_rtsval -in .stats.udp_err_rts -side left
		frame .stats.udp_err_uxt
			label .stats.udp_err_uxttxt -text "UDP error: unexpected type: "
			label .stats.udp_err_uxtval -textvariable udp_err_uxt
			pack .stats.udp_err_uxttxt .stats.udp_err_uxtval -in .stats.udp_err_uxt -side left


		pack .stats.reg .stats.replies -in .stats.all -side top
		pack .stats.udp_err_idm .stats.udp_err_iha -in .stats.all -side top 
		pack .stats.udp_err_ifa .stats.udp_err_hmtu .stats.border -in .stats.all -side top -fill x 
		pack .stats.heartbeat -in .stats.all -side top 
		pack .stats.udp_err_mgr -in .stats.all -side top
		pack .stats.udp_err_rts .stats.udp_err_uxt -in .stats.all -side top
		pack .stats.all
		after 1000 update_stats
	}


	proc update_stats {} {
		global registrations replies beacons udp_err_idm udp_err_iha
		global udp_err_ifa udp_err_hmtu heartbeat icmp_err_bts
		global icmp_err_mts icmp_err_ut icmp_err_bip icmp_err_iia
		global udp_err_mgr udp_err_rts udp_err_uxt STATS DO_STATS
		if {$DO_STATS == "NO"} {
			return
		}

		set stat_values [eval list [get_mnd_info $STATS]]
		set registrations [lindex $stat_values 0]
		set replies [lindex $stat_values 1]
		set udp_err_idm [lindex $stat_values 2]
		set udp_err_iha [lindex $stat_values 3]
		set udp_err_ifa [lindex $stat_values 4]
		set udp_err_hmtu [lindex $stat_values 5]
		set heartbeat [lindex $stat_values 6]
		set udp_err_mgr [lindex $stat_values 7]
		set udp_err_rts [lindex $stat_values 8]
		set udp_err_uxt [lindex $stat_values 9]

		after 1000 update_stats
	}
